// C Source File
//
// Created 13/04/2002; 19:10:23
//
// Nibble -Classic- Version 1.02
//
// By David Coz  coz.hubert@infonie.fr
//

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>
#include "levels_nib.h"         // Include All Header Files

//Sprites Definition

char snake[8] ={0x3C,0x7A,0xFD,0xFF,0xCF,0xEF,0x76,0x3C};// Snake Sprite
char brick[8]={0xFF,0xAB,0xD5,0xAB,0xD5,0xAB,0xD5,0xFF};// Blocks for the frame
char food[8]={0x00,0x42,0x24,0x18,0x18,0x24,0x42,0x00};// the Cross
char block[8]={0xFD,0xFD,0xFD,0xFD,0xFD,0xFD,0x01,0xFF};// Block for the levels


/*Structure for saving highscores...*/

typedef struct
  {
    char name[10];
    unsigned long score;
  } HSC_ITEM;



/*Function to input your name (thanks to Zeljko Juric with Cave Blaster...)*/
 
 void input_str(char *str)
{
ClrScr();
  int i=0,key=0;
    FontSetSys(F_8x10);
  DrawStr(10,10,"CONGRATULATIONS!",A_NORMAL);
  FontSetSys(F_6x8);
  DrawStr(10,30,"You are First!",A_NORMAL);
  DrawStr(10,50,"Enter Your Name:",A_NORMAL);
  
  while(key!=13)
    {
      str[i]='_'; str[i+1]=' '; str[i+2]=0;
      DrawStr(30,60,str,A_REPLACE);
      key=ngetchx();
      
      //Check if the char can be printed...
      if(key>=' '&&key<='~'&&i<8) str[i++]=key;
      
      //if you press delete...
      if(key==257&&i)
      {
       	i--;
      }
}
//terminates the string with '0'
str[i]=0;
}



/*Find the Hardware Version for adjusting speed (found in TIGCC help)*/
unsigned long GetHardwareVersion ()
{
  unsigned long hwpb, *rombase;
  rombase = (unsigned long *)((*(unsigned long *)0xC8) & 0x600000);
  hwpb = rombase[65];
  return (hwpb - (unsigned long)rombase  < 0x10000 &&
    *(unsigned short *)hwpb > 22 ? *(unsigned long *)(hwpb + 22) : 1);
}

// Position of the Cross
int x_food,y_food;


// function to draw the level
void load_world(int world)
{
// This function is a bit hard...
// Firts it draws the 2 sprites(only 8*8!!!) of the level
// Then if a pixel(x,y) is busy in the sprites,a block is
// drawn depending on x,y...

int i,j;
//draw the 2 sprites of the level...
	Sprite8(2,2,8,level_def[2*world],LCD_MEM,SPRT_OR);
	Sprite8(10,2,8,level_def[2*world+1],LCD_MEM,SPRT_OR);

//Check the pixels of the sprites....
	for (i=0;i<20;i++)
		for (j=0;j<10;j++)
		{
	//if the pixel(i,j) is busy,then draw a block at 8*i,8*j
			if (GetPix(i,j))
			Sprite8(i*8,j*8,8,block,LCD_MEM,SPRT_OR);
	  }
//Clear the 2 sprites of the level...
Sprite8(2,2,8,level_def[2*world],LCD_MEM,SPRT_XOR);
	Sprite8(10,2,8,level_def[2*world+1],LCD_MEM,SPRT_XOR);
	
}

// Function that places the Cross
void place_food()
{
int x,y;
//Old Position
x=x_food;
y=y_food;

//check if the new position is already busy and if the 
//new postion is different from the old one..
while (GetPix(8*(x_food)+1,8*(y_food)+2)||(x==x_food&&y==y_food))
{
//New Postion
	x_food=1+random(19);
	y_food=1+random(9);
}
//Draw the Cross..
	Sprite8(x_food*8,y_food*8,8,food,LCD_MEM,SPRT_OR);

}

// Main Function
void _main(void)
{
//initial Highscores...
static HSC_ITEM bestscore[15]={{"David",10},{"David",10},
    {"David",10},{"David",10},{"David",10},
    {"David",10},{"David",10},{"David",10},{"David",10},{"David",10},
    {"David",10},{"David",10},
    {"David",10},{"David",10},{"David",10}};

//Speed definition : name and speed value...
 HSC_ITEM level[5]={{"Very Easy",19},{"Easy     ",16},{"Medium    ",13},
{"Hard     ",10},{"Very Hard",8}};

//the 3 modes
char modes[3][30]={"Normal  ","Survival  ","Dirty   "};


while(1)
{

int key,choice=0,level_choice=0;

ClrScr();

//draw the 'Nibble' title...
BitmapPut(4,1,(BITMAP *)&(unsigned char[]){0,40,0,152,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x00,0x00,0xC0,0x00,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x80,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xC0,0x78,0x00,0x00,0xFF,0xE0,0x00,0x0F,0xFE,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xC0,0x78,0x00,0x3F,0xFF,0xF0,0x03,0xFF,0xFF,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xC0,0x78,0x00,0xFF,0xF0,0x70,0x0F,0xFF,0x07,0x00,0x7E,0x00,0x00,0xE0,0x00,0x00,0x00,0xC0,0x1F,0xC0,0x78,0x00,0xFF,0x80,0x38,0x0F,0xF8,0x03,0x80,0x7E,0x00,0x03,0xFF,0xFF,0x00,0x01,0xC0,0x1F,0xF0,0x7F,0xE0,0xFE,0x00,0x18,0x0F,0xE0,0x01,0x80,0x7C,0x00,0x03,0xFF,0xFF,0xE0,0x01,0xC1,0x9F,0xFF,0xF8,0x00,0xF8,0x00,0x18,0x0F,0x80,0x01,0x80,0x7C,0x00,0x03,0xFF,0xFF,0xF0,0x01,0xE0,0x1F,0x7C,0x78,0x00,0xF0,0x00,0x18,0x0F,0x00,0x01,0x80,0x7C,0x00,0x03,0xFF,0xFE,0x38,0x03,0xE0,0x1F,0x00,0x70,0x00,0xF0,0x00,0x18,0x0F,0x00,0x01,0x80,0x7C,0x00,0x01,0xFF,0xF0,0x00,0x03,0xE0,0x1F,0x00,0x70,0x00,0xF0,0x00,0x18,0x0F,0x00,0x01,0x80,0x7C,0x00,0x00,0xE0,0x00,0x00,0x03,0xE0,0x0F,0x00,0x70,0x00,0xF0,0x00,0x30,0x0F,0x00,0x03,0x00,0x78,0x00,0x00,0xC0,0x00,0x00,0x03,0xE0,0x0F,0x00,0x70,0x00,0xF0,0x00,0x30,0x0F,0x00,0x03,0x00,0x78,0x00,0x00,0xC0,0x00,0x00,0x07,0xE0,0x0F,0x00,0x70,0x00,0xF0,0x00,0x60,0x0F,0x00,0x06,0x00,0x78,0x00,0x01,0xC0,0x00,0x00,0x0F,0xE0,0x0F,0x00,0x70,0x00,0xF0,0x00,0xC0,0x0F,0x00,0x0C,0x00,0x78,0x00,0x01,0x80,0x00,0x00,0x0F,0xF0,0x0E,0x00,0x70,0x00,0xF8,0x01,0x80,0x0F,0x80,0x18,0x00,0x70,0x00,0x01,0x80,0x00,0x00,0x0F,0x70,0x1E,0x00,0x70,0x00,0x78,0x07,0x00,0x07,0x80,0x70,0x00,0x70,0x00,0x01,0x80,0x00,0x00,0x0F,0x30,0x1E,0x00,0x70,0x00,0x78,0xFF,0xC0,0x07,0x8F,0xFC,0x00,0x70,0x00,0x01,0x80,0x00,0x00,0x0F,0x30,0x1E,0x00,0x70,0x00,0x7F,0xFF,0xF0,0x07,0xFF,0xFF,0x00,0x70,0x00,0x01,0xBF,0x80,0x00,0x0F,0x30,0x3C,0x00,0x70,0x00,0x7F,0xE0,0x70,0x07,0xFE,0x07,0x00,0x70,0x00,0x01,0xFF,0xFC,0x00,0x0F,0x18,0x7C,0x00,0x70,0x00,0x7C,0x00,0x38,0x07,0xC0,0x03,0x80,0x70,0x00,0x01,0xFC,0x00,0x00,0x0F,0x18,0x78,0x00,0x70,0x00,0x78,0x00,0x1C,0x07,0x80,0x01,0xC0,0x60,0x00,0x01,0x80,0x00,0x00,0x0F,0x1C,0xF8,0x00,0x70,0x00,0x78,0x00,0x0C,0x07,0x80,0x00,0xC0,0x60,0x00,0x01,0x80,0x00,0x00,0x0F,0x1C,0xF0,0x00,0x70,0x00,0x78,0x00,0x0E,0x07,0x80,0x00,0xE0,0x60,0x00,0x01,0x80,0x00,0x00,0x1F,0x0C,0xF0,0x00,0x70,0x00,0x78,0x00,0x06,0x07,0x80,0x00,0x60,0x60,0x03,0x01,0x80,0x00,0x00,0x1E,0x0C,0xF0,0x00,0x70,0x00,0x78,0x00,0x06,0x07,0x80,0x00,0x60,0x60,0x00,0x01,0x80,0x00,0x00,0x1E,0x0C,0xF0,0x00,0x70,0x00,0x7C,0x00,0x06,0x07,0xC0,0x00,0x60,0x60,0x00,0x00,0xC0,0x00,0x00,0x1E,0x0F,0xE0,0x00,0x70,0x00,0x7C,0x00,0x06,0x07,0xC0,0x00,0x60,0xE0,0x00,0x00,0xC0,0x00,0x00,0x3E,0x07,0xE0,0x00,0x70,0x00,0xFC,0x00,0x06,0x0F,0xC0,0x00,0x60,0xE0,0x00,0x00,0xC0,0x00,0x00,0x7E,0x07,0xE0,0x00,0x30,0x00,0xFE,0x00,0x0C,0x0F,0xE0,0x00,0xC0,0xC0,0x01,0xC0,0x60,0x00,0x00,0x7E,0x07,0xC0,0x00,0x30,0x18,0xFF,0x00,0x38,0x0F,0xF0,0x01,0x80,0xC0,0x03,0xE0,0x70,0x00,0x00,0x7E,0x07,0xC0,0x00,0x7C,0x01,0xFF,0x01,0xF8,0x1F,0xF0,0x1F,0x80,0xC0,0xFF,0xE0,0x78,0x00,0x00,0x3E,0x03,0xC0,0x03,0xFF,0xC1,0xFF,0x80,0x30,0x1F,0xF8,0x03,0x00,0xFF,0xFF,0xF0,0x3C,0x00,0x00,0x3C,0x03,0xC0,0x07,0xFF,0xF3,0xFF,0xE0,0x00,0x3F,0xFE,0x00,0x00,0xFF,0xFF,0xE0,0x1F,0x00,0x00,0x00,0x01,0xC0,0x0F,0xFE,0x03,0xFE,0x38,0x00,0x3F,0xE3,0x80,0x00,0xFF,0xFF,0xE0,0x3F,0xFC,0x00,0x00,0x00,0x00,0x1F,0xF8,0x03,0xF8,0x0F,0xE0,0x3F,0x80,0xFE,0x01,0xFF,0xFF,0x00,0x01,0xFF,0x80,0x18,0x00,0x00,0x1F,0xF8,0x01,0xC0,0x00,0x00,0x1C,0x00,0x00,0x01,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xD8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
},&(SCR_RECT){{0,0,239,127}},A_REPLACE);
FontSetSys(F_8x10);
DrawStr(42,43,"-Classic-",A_NORMAL);

FontSetSys(F_4x6);
DrawStr(36,88,"2002 v 1.00 by David Coz",A_NORMAL);
DrawStr(41,94,"Coz.hubert@infonie.fr",A_NORMAL);

 FontSetSys(F_8x10);
 
 while (key!=13)
{
DrawStr(28,65,"Mode:",A_REPLACE);

//Draw the chosen mode
DrawStr(73,65,modes[choice],A_REPLACE);

key=ngetchx();
if (key==344)
{
choice++;
	if (choice==3)
choice=0;
}
if (key==338)
{
choice--;
	if (choice==-1)
choice=2;
}
if (key==264)
{
return;
}
}
DrawStr(28,65,"              ",A_REPLACE);
key=0;
FontSetSys(F_6x8);
 

 while (key!=13)
{
//Draw the chosen Speed and highscore...
DrawStr(13,62,"Speed :",A_NORMAL);
DrawStr(60,62,level[level_choice].name,A_REPLACE);
DrawStr(13,73,"Best  :",A_NORMAL);
DrawStr(60,73,"               ",A_REPLACE);
DrawStr(110,73,bestscore[5*choice+level_choice].name,A_NORMAL);
printf_xy(60,73,"%ld by",bestscore[5*choice+level_choice].score);

key=ngetchx();
if (key==344)
{
level_choice++;
	if (level_choice==5)
level_choice=0;
}
if (key==338)
{
level_choice--;
	if (level_choice==-1)
level_choice=4;
}
if (key==264)
{
return;
}
}

//label for quick restart...
restart:

x_food=0;
y_food=0;
randomize();

int x,y, // Your Snake position...
length,  // lenght of the snake...
lifes=3 
,move_x,move_y,  // Your Snake Direction 
                 // (ex:to the right move_x=1 ; move_y=0)
                 

 moves , // number of moves your snake made...
 score=0,world=0,speed,i,
hw=GetHardwareVersion() //Calc Hardware number...
,eat;  // Indicates that just hit a cross...


//Adjust Speed depending on the calc hardware and Speed Level...
speed=20*level[level_choice].score*(hw==2 ? 6 :5);

//Save your previous Snake Position...
char *x_record = calloc (3000,sizeof(char));
char *y_record = calloc (3000,sizeof(char));

//Quick restart in 'Normal' Mode
restart2:

moves=0;
// In 'Normal' mode,lenght increases with the levels
length=4+world*3;
// Initial Position
x=1;
y=1;
move_x=1;
move_y=0;
eat=0;

ClrScr();
//load level if in 'Normal'
if (choice==0&&world>0)
load_world(world-1);

//Draw the frame
for (i=0;i<11;i++)
{
Sprite8(0,i*8,8,brick,LCD_MEM,SPRT_OR);
Sprite8(152,i*8,8,brick,LCD_MEM,SPRT_OR);
}
for (i=0;i<20;i++)
{
Sprite8(i*8,0,8,brick,LCD_MEM,SPRT_OR);
Sprite8(i*8,80,8,brick,LCD_MEM,SPRT_OR);
}
//Place the cross
place_food();

//dissable all interrupts
OSSetSR(0x0400);

FontSetSys(F_4x6);
DrawStr(0,91,modes[choice],A_REPLACE);
DrawStr(35,91,level[level_choice].name,A_REPLACE);
printf_xy(75,91,"Score: %d ",score);
if (choice==0)
printf_xy(120,91,"Life: %d ",lifes);

// while you don't press ESC
while(!(_rowread(~((short)(1<<6))) & (1<<0)))
{
	
	//Waiting loop depending on Speed
	for (i=0;i<speed;i++)
   {
   //'Right' is pressed	
   		if (_rowread(0x7E)&0x08)
			{
			move_x=1;move_y=0;
	}
		//'Left' is pressed
	if (_rowread(0x7E)&0x02)
			{
			move_x=-1;move_y=0;
	}
	//'Down' is pressed
		if (_rowread(0x7E)&0x04)
	{
			move_x=0;move_y=1;
	}
	//'Up' is pressed
	if (_rowread(0x7E)&0x01)
	{
			move_x=0;move_y=-1;
  }		
}

//Save the Snake postion in Records
x_record[moves]=x;
y_record[moves]=y;

//Change x,y depending on your direction...1
x+=move_x;
y+=move_y; 


// The Snake touches a wall...
if (GetPix(x*8+1,8*y+2)&&(x!=x_food||y!=y_food))
{
//if not in 'Normal' or if no more lifes, Game Over!
if (choice!=0||lifes==0)
break;

//if in 'Normal' mode and lifes>0
FontSetSys(F_8x10);
DrawStr(25,30,"What a Shame !!!",A_REPLACE);
while(ngetchx()!=13);
lifes--;
FontSetSys(F_4x6);
goto restart2;
}

// if you make more moves than the lenght of your snake,clear
// a 'Snake' Sprite position,recorded in x_record,y_record
if (moves>length&&eat==0)
Sprite8(8*(x_record[moves-length]),8*(y_record[moves-length]),8,snake,LCD_MEM,SPRT_XOR);

if (eat!=0)
eat--;

//if you hit the cross..
if (x==x_food&&y==y_food)
{
//increases your snake lenght..
	length+=2;
//place then draw a new cross
	place_food();
	Sprite8(x*8,y*8,8,food,LCD_MEM,SPRT_XOR);
	eat+=(choice==2 ? 1 :2);
	score++;
printf_xy(100,91,"%d",score);
//In 'normal',if you hit 8 crosses in a level,change the level
if (score%8==0&&choice==0)
{
FontSetSys(F_8x10);
	world++;
if (world!=11)
	DrawStr(30,30,"Next Level !!!",A_REPLACE);
else
{
//if you beat the 10 levels...
	DrawStr(15,20,"CONGRATULATIONS !!!",A_REPLACE);
DrawStr(0,45,"You finish the GAME !",A_REPLACE);

}
	while(ngetchx()!=13)
	FontSetSys(F_4x6);
	if (world&1)
	lifes++;
	if (world!=11)
	goto restart2;
break;	
}
}
//draw your snake
Sprite8(8*x,8*y,8,snake,LCD_MEM,SPRT_OR);

//you made another move
moves++;

}

//GAME OVER

//Free the records
free(x_record);
free(y_record);



	FontSetSys(F_8x10);
	DrawStr(35,30,"GAME OVER",A_REPLACE);
	FontSetSys(F_6x8);

	DrawStr(25,50,"                       ",A_REPLACE);
printf_xy(25,50,"Your Score is :%d",score);
	key=0;
	while (key!=13&&key!=264)
	{
	key=ngetchx();
	} 
//check if you made a highscore...
if (score>bestscore[choice*5+level_choice].score)
{
input_str(bestscore[choice*5+level_choice].name);
bestscore[choice*5+level_choice].score=score;
}	
//if press enter,quick restart,else return in main menu...
if (key==13)
goto restart;
}

}
	
